﻿Public Class Form1


    Private client As uPLibrary.Networking.M2Mqtt.MqttClient

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        End
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        System.Windows.Forms.Control.CheckForIllegalCrossThreadCalls = False
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles btnSubscribe.Click
        ' test.mosquitto.org
        Dim s() As String = {Me.txtTopic1.Text, Me.txtTopic2.Text, Me.txtTopic3.Text}
        Dim b() As Byte = {uPLibrary.Networking.M2Mqtt.Messages.MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE,
                           uPLibrary.Networking.M2Mqtt.Messages.MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE,
                           uPLibrary.Networking.M2Mqtt.Messages.MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE}
        client.Subscribe(s, b)
        AddHandler client.MqttMsgPublishReceived, AddressOf Recv
    End Sub

    Private Sub Recv(sender As Object, e As uPLibrary.Networking.M2Mqtt.Messages.MqttMsgPublishEventArgs)
        Dim s As String = ""
        For Each c As Byte In e.Message
            s &= ChrW(c)
        Next
        If Trim(e.Topic) = Trim(Me.txtTopic1.Text) Then
            Me.txtRetMessage1.AppendText(s & vbCrLf)
            Me.lblRetQos1.Text = e.QosLevel.ToString
            Me.lblRetDup1.Text = e.DupFlag.ToString
            Me.lblRetRetain1.Text = e.Retain.ToString
        ElseIf Trim(e.Topic) = Trim(Me.txtTopic2.Text) Then
            Me.txtRetMessage2.AppendText(s & vbCrLf)
            Me.lblRetQos2.Text = e.QosLevel.ToString
            Me.lblRetDup2.Text = e.DupFlag.ToString
            Me.lblRetRetain2.Text = e.Retain.ToString
        ElseIf Trim(e.Topic) = Trim(Me.txtTopic3.Text) Then
            Me.txtRetMessage3.AppendText(s & vbCrLf)
            Me.lblRetQos3.Text = e.QosLevel.ToString
            Me.lblRetDup3.Text = e.DupFlag.ToString
            Me.lblRetRetain3.Text = e.Retain.ToString
        End If
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles btnConnect.Click
        client = New uPLibrary.Networking.M2Mqtt.MqttClient(Me.txtBrokerAddress.Text, Val(Me.txtBrokerPort.Text), False, Nothing)
        Dim clientId As String = Guid.NewGuid().ToString()
        client.Connect(clientId)
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles btnDisconnect.Click
        client.Disconnect()
        RemoveHandler client.MqttMsgPublishReceived, AddressOf Recv
    End Sub

    Private Sub Label3_Click(sender As Object, e As EventArgs) Handles Label3.Click

    End Sub

    Private Sub Label14_Click(sender As Object, e As EventArgs) Handles lblRetQos2.Click

    End Sub

    Private Sub Label13_Click(sender As Object, e As EventArgs) Handles lblRetDup2.Click

    End Sub

    Private Sub Label12_Click(sender As Object, e As EventArgs) Handles lblRetRetain2.Click

    End Sub
End Class
